using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using Exferia_KairosPRO._1_Modelos;
using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_AusenciasProgramadas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_KRS_AusenciasProgramadas_Listado_Modelo> g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<dynamic> lst_KRS = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta.................................................................
                ConsultaRellenar_Listado(obj_KairosProEntities, _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //........................................................................

                if ((g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo != null) && (g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Count() > 0))
                {
                    lst_KRS = g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return lst_KRS;
        }
        public override dynamic Obtener_RegistroListado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            KairosProEntities obj_KairosProEntities = null;
            dynamic dnm_KRS = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_Listado(obj_KairosProEntities, _lst_CamposConRelacionABuscar, _lng_id, _lst_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...............................................................

                if ((g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo != null) && (g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Count() > 0))
                {
                    dnm_KRS = g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return dnm_KRS;
        }
        protected override void ConsultaRellenar_Listado(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {

                string str_SQL =
                    " SELECT " +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.id) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.id) + "," +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.codigoCliente) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "," +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.fechaDesde) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + "," +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.fechaHasta) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + "," +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.totalDias) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.totalDias) + "," +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.totalHoras) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.totalHoras) + "," +
                            //ids
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.idEmpleado) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "," +
                            nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.idAusenciaProgramadaTipo) + " = " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "," +
                            //KRS_Empleados
                            (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Empleado)))
                                ?
                                    (
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Empleado_Codigo) + " = " + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.codigoValidacion) + "," +
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Empleado_Descripcion) + " =" + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.nombre) + ","
                                      )
                                :
                                    (
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Empleado_Codigo) + " = ''," +
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Empleado_Descripcion) + " = ''," 
                                    )
                            ) +
                            //KRS_AusenciasProgramadasTipos
                            (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos)))
                                ?
                                    (
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos_Codigo) + " = " + nameof(KRS_AusenciasProgramadasTipos) + "." + nameof(KRS_AusenciasProgramadasTipos.codigo) + "," +
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos_Descripcion) + " =" + nameof(KRS_AusenciasProgramadasTipos) + "." + nameof(KRS_AusenciasProgramadasTipos.descripcion)  
                                    )
                                :
                                    (
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos_Codigo) + " = ''," +
                                        nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos_Descripcion) + " = ''"
                                    )
                            ) +
                    " FROM " + nameof(KRS_AusenciasProgramadas) +
                            //KRS_Empleados
                            (
                                 (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.Empleado)))
                                    ?
                                        (
                                         " LEFT JOIN " + nameof(KRS_Empleados) + " ON " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + " = " + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.id) + " and " +
                                                                                          nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + " = " + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.codigoCliente) 
                                        )
                                    : ("")
                            ) +
                            //KRS_AusenciasProgramadasTipos
                            (
                                 (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_KRS_AusenciasProgramadas_Listado_Modelo.AusenciasProgramadasTipos)))
                                    ?
                                        (
                                         " LEFT JOIN " + nameof(KRS_AusenciasProgramadasTipos) + " ON " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + " = " + nameof(KRS_AusenciasProgramadasTipos) + "." + nameof(KRS_AusenciasProgramadasTipos.id)
                                        )
                                    : ("")
                            ) +
                    " WHERE " +
                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " IS null AND " +
                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente AND " +
                            (_lng_id > -1
                                ? nameof(KRS_AusenciasProgramadas) + "." + (nameof(KRS_AusenciasProgramadas.id) + "=@id ")
                                : " 1 = 1 "
                            );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@codigoCliente" , Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                    new SqlParameter("@id" , _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_KRS_AusenciasProgramadas_Listado_Modelo = _dbcontext.Database.SqlQuery<INTERNO_KRS_AusenciasProgramadas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
    
        }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(KairosProEntities _dbcontext, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
          
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;
        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                string str_SQL =
                   " SELECT " +
                        nameof(KRS_AusenciasProgramadas.id) + "," +
                        nameof(KRS_AusenciasProgramadas.codigoCliente) + "," +
                        nameof(KRS_AusenciasProgramadas.idEmpleado) + "," +
                        nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "," +
                        nameof(KRS_AusenciasProgramadas.fechaDesde) + "," +
                        nameof(KRS_AusenciasProgramadas.fechaHasta) + "," +
                        nameof(KRS_AusenciasProgramadas.fechaBorrado) + "," +
                        nameof(KRS_AusenciasProgramadas.totalDias) + "," +
                        nameof(KRS_AusenciasProgramadas.totalHoras) +
               " FROM " + nameof(KRS_AusenciasProgramadas) +
               " WHERE " +
                            nameof(KRS_AusenciasProgramadas.id) + "=@id and " +
                            nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_KairosProEntities.Database.SqlQuery<KRS_AusenciasProgramadas>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //KRS_AusenciasProgramadasTipos ##########################################################################################
                    ThreadStart obj_ThreadStart_AUSENCIASPROGRAMADASTIPOS = new ThreadStart(Obtener_AusenciasProgramadasTipos_Modelo_Obtener);
                    Thread obj_Thread_AUSENCIASPROGRAMADASTIPOS = new Thread(obj_ThreadStart_AUSENCIASPROGRAMADASTIPOS);
                    obj_Thread_AUSENCIASPROGRAMADASTIPOS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_AusenciasProgramadasTipos_Modelo_Obtener()
        {
            try
            {
                KRS_AusenciasProgramadasTipos_Datos obj_KRS_AusenciasProgramadasTipos_Datos = new KRS_AusenciasProgramadasTipos_Datos();
                g_dnm_Modelo_Obtener.KRS_AusenciasProgramadasTipos = obj_KRS_AusenciasProgramadasTipos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idAusenciaProgramadaTipo, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }

        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_CampoBusqueda, string _str_Filtro)
        {
            throw new NotImplementedException();
        }

        public bool Validar_Existe_Por_Fechas(long _lng_CodigoCliente,long _lng_idEmpleado,DateTime _dtt_FechaDesde,DateTime _dtt_FechaHasta)
        {
            KairosProEntities obj_KairosProEntities = null;

            bool bol_Existe= false;
            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                string str_SQL =
                   " SELECT " +
                        nameof(KRS_AusenciasProgramadas.id) + 
                    " FROM " + nameof(KRS_AusenciasProgramadas) +
                    " WHERE " +
                                nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and " +
                                nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                " ( " +
                                    " ( " +
                                        nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@fechaDesde and " +
                                        " ( " +
                                            nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                            nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@fechaDesde " +
                                        " ) " +
                                    " )  or " +
                                    " ( " +
                                        nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@fechaHasta and " +
                                        " ( " +
                                            nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                            nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@fechaHasta " +
                                        " ) " +
                                    " )  " +
                                    " ) ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente", _lng_CodigoCliente),
                     new SqlParameter("@fechaDesde", _dtt_FechaDesde),
                     new SqlParameter("@fechaHasta", _dtt_FechaHasta)
                };

                //Rellenar el Modelo
                long? lng_Aux = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL, arr_Parametros).FirstOrDefault();
                if (lng_Aux!=null && lng_Aux.Value>0)
                {
                    bol_Existe = true;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return bol_Existe;
        }


        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRS_AusenciasProgramadas g_mdl_KRS_AusenciasProgramadas = null;
        public KRS_AusenciasProgramadas Obtener_Modelo_Por_Id(long _lng_id, long _lng_CodigoCliente,bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.id) + "=@id and " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@id",  _lng_id),
                    new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_AusenciasProgramadasTipos);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_AusenciasProgramadas;
        }
        public KRS_AusenciasProgramadas Obtener_Modelo_Por_EmpleadoClienteFecha_SinHoras(long _lng_idEmpleado, long _lng_CodigoCliente, DateTime _dtt_Fecha, bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                        " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ",103) =@Fecha and " +
                                        " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ",103) =@Fecha and " +
                                        " ( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.totalDias) + " is null) and  " +
                                        " ( " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.totalDias) + " >0) ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@codigoCliente",  _lng_CodigoCliente),
                    new SqlParameter("@Fecha",  _dtt_Fecha.ToString("dd/MM/yyyy"))
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_AusenciasProgramadasTipos);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_Modelo_Por_EmpleadoClienteFecha_SinHoras), true);
            }

            return g_mdl_KRS_AusenciasProgramadas;
        }
        public KRS_AusenciasProgramadas Obtener_Modelo_Por_EmpleadoClienteFecha(long _lng_idEmpleado, long _lng_CodigoCliente, string _str_Fecha)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                        " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ",103) =@Fecha and " +
                                        " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ",103) =@Fecha ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@codigoCliente",  _lng_CodigoCliente),
                    new SqlParameter("@Fecha",  _str_Fecha)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         false);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_Modelo_Por_EmpleadoClienteFecha_SinHoras), true);
            }

            return g_mdl_KRS_AusenciasProgramadas;
        }

        #region Ejecutar_Consulta_Modelo
        private static int g_int_TotalHilos_Modelo = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros,
                                              bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_KRS_AusenciasProgramadas = obj_KairosProEntities.Database.SqlQuery<KRS_AusenciasProgramadas>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_mdl_KRS_AusenciasProgramadas != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                    }

                    //KRS_AusenciasProgramadasTipos ##########################################################################################
                    if (_bol_Cargar_AusenciasProgramadasTipos)
                    {
                        ThreadStart obj_ThreadStart_AUSENCIAPROGRAMADATIPO = new ThreadStart(Obtener_AusenciasProgramadasTipos_Modelo);
                        Thread obj_Thread_AUSENCIAPROGRAMADATIPO = new Thread(obj_ThreadStart_AUSENCIAPROGRAMADATIPO);
                        obj_Thread_AUSENCIAPROGRAMADATIPO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }
        #region Tablas Relacionadas
        private void Obtener_AusenciasProgramadasTipos_Modelo()
        {
            try
            {
                KRS_AusenciasProgramadasTipos_Datos obj_KRS_AusenciasProgramadasTipos_Datos = new KRS_AusenciasProgramadasTipos_Datos();
                g_mdl_KRS_AusenciasProgramadas.KRS_AusenciasProgramadasTipos = obj_KRS_AusenciasProgramadasTipos_Datos.Obtener_Modelo_Por_Id(g_mdl_KRS_AusenciasProgramadas.idAusenciaProgramadaTipo, g_mdl_KRS_AusenciasProgramadas.codigoCliente);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        #region Modelo Listado
        private List<KRS_AusenciasProgramadas> g_lst_KRS_AusenciasProgramadas = null;

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids,bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_AusenciasProgramadas) ,
                                                                                            nameof(KRS_AusenciasProgramadas.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);



                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                                nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                                str_Filtros_IDS;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));

                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros,
                                                     _bol_Cargar_AusenciasProgramadasTipos,
                                                     false);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_IdsEmpleadosFechas(long _lng_CodigoCliente,List<long> _lst_idEmpleado, DateTime _dtt_FechaDesde,DateTime _dtt_FechaHasta)
        {
            try
            {

                if (_lst_idEmpleado != null && _lst_idEmpleado.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_Empleados = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_AusenciasProgramadas),
                                                                                            nameof(KRS_AusenciasProgramadas.idEmpleado),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_idEmpleado);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                                nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                                " ( " + 
                                                    " ( " + 
                                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ">=@fechaDesde and " +
                                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@fechaHasta " +
                                                    " ) " +
                                                    " OR " + 
                                                    " ( " + 
                                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                                        " ( " +
                                                            "( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null ) and " +
                                                              nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + "<=@fechaHasta and  " +
                                                              nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@fechaDesde  " +
                                                        " ) " +
                                                    " ) " +
                                                " ) and " +
                                                str_Filtros_Empleados;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", _lng_CodigoCliente));
                    lst_Parametros.Add(new SqlParameter("@fechaDesde", _dtt_FechaDesde));
                    lst_Parametros.Add(new SqlParameter("@fechaHasta", _dtt_FechaHasta));

                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros,
                                                     true,
                                                     true);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdsEmpleadosFechas), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_EmpleadoEjercicioTipoAusenciaProgramada(long _lng_idEmpleado,long _lng_idAusenciaProgramadaTipo, GEN_EjerciciosActivos_Empresa _mdl_GEN_EjerciciosActivos_Empresa, bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and  " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "=@idAusenciaProgramadaTipo and  " +
                                             //Fechas
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ">=@Fechainicio and " +
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@Fechafin and " +
                                             " ( " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                               " ( " +
                                                    " ( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null) and " + 
                                                    nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@Fechainicio and " +
                                                    nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + "<=@Fechafin"  +
                                               " ) " +
                                             " ) ";


                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@idAusenciaProgramadaTipo",  _lng_idAusenciaProgramadaTipo),
                    new SqlParameter("@Fechainicio",  _mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaInicio),
                    new SqlParameter("@Fechafin",  _mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaFin)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros,
                                                    _bol_Cargar_AusenciasProgramadasTipos,
                                                    false);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadoEjercicioTipoAusenciaProgramada), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_EmpleadoFechasTipoAusenciaProgramada(long _lng_idEmpleado, long _lng_idAusenciaProgramadaTipo, DateTime _dtt_Desde,DateTime _dtt_Hasta, bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and  " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "=@idAusenciaProgramadaTipo and  " +
                                             //Fechas
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ">=@Fechainicio and " +
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@Fechafin and " +
                                             " ( " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                               " ( " +
                                                    " ( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null) and " +
                                                    nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@Fechainicio and " +
                                                    nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + "<=@Fechafin" +
                                               " ) " +
                                             " ) ";


                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@idAusenciaProgramadaTipo",  _lng_idAusenciaProgramadaTipo),
                    new SqlParameter("@Fechainicio",  _dtt_Desde),
                    new SqlParameter("@Fechafin",  _dtt_Hasta)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros,
                                                    _bol_Cargar_AusenciasProgramadasTipos,
                                                    false);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadoFechasTipoAusenciaProgramada), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_EmpleadoEjercicio(long _lng_idEmpleado, GEN_EjerciciosActivos_Empresa _mdl_GEN_EjerciciosActivos_Empresa, bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and  " +
                                             //Fechas
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ">=@Fechainicio and " +
                                             nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@Fechafin and " +
                                             " ( " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                               " ( " +
                                                    " ( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null) and " +
                                                    nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@Fechainicio and " +
                                                    nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + "<=@Fechafin" +
                                               " ) " +
                                             " ) ";


                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@Fechainicio",  _mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaInicio),
                    new SqlParameter("@Fechafin",  _mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaFin)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros,
                                                    _bol_Cargar_AusenciasProgramadasTipos,
                                                    false);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadoEjercicio), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_EmpleadoFechas_ConHoras(long _lng_idEmpleado, string _str_Fecha)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and  " +
                                            nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and  " +
                                           " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ",103) =@Fecha and " +
                                           " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ",103) =@Fecha and " +
                                           " ( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.totalHoras) + " is null) and  " +
                                            " ( " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.totalHoras) + " >0)  "; 


                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@Fecha",  _str_Fecha)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros,
                                                    true,
                                                    false);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadoFechas_ConHoras), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_IdEmpleadosEjercicio(List<long> _lst_idEmpleado, 
                                                                                            long _lng_CodigoCliente,
                                                                                            GEN_EjerciciosActivos_Empresa _mdl_GEN_EjerciciosActivos_Empresa, 
                                                                                            bool _bol_Cargar_AusenciasProgramadasTipos)
        {
            try
            {

                if (_lst_idEmpleado != null && _lst_idEmpleado.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_Empleados = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_AusenciasProgramadas),
                                                                                            nameof(KRS_AusenciasProgramadas.idEmpleado),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_idEmpleado);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                                nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                                nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                                //Fechas
                                                nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + ">=@Fechainicio and " +
                                                nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@Fechafin and " +
                                                " ( " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                                   " ( " +
                                                        " ( not " + nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null) and " +
                                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@Fechainicio and " +
                                                        nameof(KRS_AusenciasProgramadas) + "." + nameof(KRS_AusenciasProgramadas.fechaHasta) + "<=@Fechafin" +
                                                   " ) " +
                                                " ) and " +
                                                str_Filtros_Empleados;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", _lng_CodigoCliente));
                    lst_Parametros.Add(new SqlParameter("@Fechainicio", _mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaInicio));
                    lst_Parametros.Add(new SqlParameter("@Fechafin", _mdl_GEN_EjerciciosActivos_Empresa.temporadaFechaFin));

                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros,
                                                     _bol_Cargar_AusenciasProgramadasTipos,
                                                     false);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdEmpleadosEjercicio), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }


        public List<KRS_AusenciasProgramadas> Obtener_ModeloListado_Por_EmpleadoAusenciaProgramadaTipoFechas(long _lng_idEmpleado, long _lng_CodigoCliente, long _lng_idAusenciaProgramadaTipo, DateTime _dtt_FechaDesde, DateTime _dtt_FechaHasta, int _int_DiasHoras)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_AusenciasProgramadas.fechaBorrado) + " is null and " +
                                        nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "=@idAusenciaProgramadaTipo and " +
                                        nameof(KRS_AusenciasProgramadas.fechaDesde) + ">=@fechaDesde and " +
                                        nameof(KRS_AusenciasProgramadas.fechaDesde) + "<=@fechaHasta and " +
                                        " ( " +
                                            nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null or " +
                                            " ( " +
                                                " ( not " + nameof(KRS_AusenciasProgramadas.fechaHasta) + " is null) and " +
                                                nameof(KRS_AusenciasProgramadas.fechaHasta) + "<=@fechaHasta and " +
                                                nameof(KRS_AusenciasProgramadas.fechaHasta) + ">=@fechaDesde " +
                                            " ) " +
                                        " ) and " +
                                        (_int_DiasHoras==1 
                                            ? (" ((( not " + nameof(KRS_AusenciasProgramadas.totalDias) + " is null) and " + nameof(KRS_AusenciasProgramadas.totalDias) + ">0) or " + nameof(KRS_AusenciasProgramadas.totalDias) + " is null) ") 
                                            : (" (( not " + nameof(KRS_AusenciasProgramadas.totalHoras) + " is null) and " + nameof(KRS_AusenciasProgramadas.totalHoras) + ">0) ")
                                        );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                    new SqlParameter("@codigoCliente",  _lng_CodigoCliente),
                    new SqlParameter("@idAusenciaProgramadaTipo",  _lng_idAusenciaProgramadaTipo),
                    new SqlParameter("@fechaDesde",  _dtt_FechaDesde),
                    new SqlParameter("@fechaHasta",  _dtt_FechaHasta)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros,
                                                    false,
                                                    false);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_EmpleadoAusenciaProgramadaTipoFechas), true);
            }

            return g_lst_KRS_AusenciasProgramadas;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<KRS_AusenciasProgramadasTipos> g_lst_KRS_AusenciasProgramadasTipos = null;
        private List<KRS_Empleados> g_lst_KRS_Empleados = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_AusenciasProgramadasTipos,
                                                      bool _bol_Cargar_Empleados)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRS_AusenciasProgramadas = obj_KairosProEntities.Database.SqlQuery<KRS_AusenciasProgramadas>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_KRS_AusenciasProgramadas != null && g_lst_KRS_AusenciasProgramadas.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_AusenciasProgramadasTipos ||
                    _bol_Cargar_Empleados)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //KRS_AusenciasProgramadasTipos #############################################
                        if (_bol_Cargar_AusenciasProgramadasTipos)
                        {
                            ThreadStart obj_ThreadStart_AUSENCIAPROGRAMADATIPO = new ThreadStart(Obtener_AusenciasProgramadasTipos_Modelo_Listado);
                            Thread obj_Thread_AUSENCIAPROGRAMADATIPO = new Thread(obj_ThreadStart_AUSENCIAPROGRAMADATIPO);
                            obj_Thread_AUSENCIAPROGRAMADATIPO.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //KRS_Empleados #############################################
                        if (_bol_Cargar_Empleados)
                        {
                            ThreadStart obj_ThreadStart_EMPLEADOS = new ThreadStart(Obtener_Empelados_Modelo_Listado);
                            Thread obj_Thread_EMPLEADOS = new Thread(obj_ThreadStart_EMPLEADOS);
                            obj_Thread_EMPLEADOS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (KRS_AusenciasProgramadas mdl_KRS_AusenciasProgramadas in g_lst_KRS_AusenciasProgramadas)
                        {
                            //KRS_AusenciasProgramadasTipos #############################################
                            if (_bol_Cargar_AusenciasProgramadasTipos &&
                                g_lst_KRS_AusenciasProgramadasTipos != null &&
                                g_lst_KRS_AusenciasProgramadasTipos.Count > 0)
                            {
                                mdl_KRS_AusenciasProgramadas.KRS_AusenciasProgramadasTipos = g_lst_KRS_AusenciasProgramadasTipos.Where(m => m.id == mdl_KRS_AusenciasProgramadas.idAusenciaProgramadaTipo).FirstOrDefault();
                            }

                            //KRS_Empleados #############################################
                            if (_bol_Cargar_Empleados &&
                                g_lst_KRS_Empleados != null &&
                                g_lst_KRS_Empleados.Count > 0)
                            {
                                mdl_KRS_AusenciasProgramadas.KRS_Empleados = g_lst_KRS_Empleados.Where(m => m.id == mdl_KRS_AusenciasProgramadas.idEmpleado).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                    
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }
        #region Tablas relacionadas
        private void Obtener_AusenciasProgramadasTipos_Modelo_Listado()
        {
            try
            {
                KRS_AusenciasProgramadasTipos_Datos obj_KRS_AusenciasProgramadasTipos_Datos = new KRS_AusenciasProgramadasTipos_Datos();
                g_lst_KRS_AusenciasProgramadasTipos = obj_KRS_AusenciasProgramadasTipos_Datos.Obtener_ModeloListado_Por_Ids(g_lst_KRS_AusenciasProgramadas.Select(m => m.idAusenciaProgramadaTipo).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }

        private void Obtener_Empelados_Modelo_Listado()
        {
            try
            {
                KRS_Empleados_Datos obj_KRS_Empleados_Datos = new KRS_Empleados_Datos();
                g_lst_KRS_Empleados = obj_KRS_Empleados_Datos.Obtener_ModeloListado_Por_Ids(g_lst_KRS_AusenciasProgramadas.Select(m => m.idEmpleado).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        #endregion
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                        nameof(KRS_AusenciasProgramadas.id) + "," +
                        nameof(KRS_AusenciasProgramadas.codigoCliente) + "," +
                        nameof(KRS_AusenciasProgramadas.idEmpleado) + "," +
                        nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "," +
                        nameof(KRS_AusenciasProgramadas.fechaDesde) + "," +
                        nameof(KRS_AusenciasProgramadas.fechaHasta) + "," +
                        nameof(KRS_AusenciasProgramadas.fechaBorrado) + "," +
                        nameof(KRS_AusenciasProgramadas.totalDias) + "," +
                        nameof(KRS_AusenciasProgramadas.totalHoras) +
                " FROM " + nameof(KRS_AusenciasProgramadas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRS_AusenciasProgramadas mdl_KRS_AusenciasProgramadas_AGrabar = (KRS_AusenciasProgramadas)_mdl_obj;
                KRS_AusenciasProgramadas mdl_KRS_AusenciasProgramadas_DatosViejos = new KRS_AusenciasProgramadas();

                KRS_AusenciasProgramadas mdl_KRS_AusenciasProgramadas_Final = Obtener_Modelo_Por_Id(mdl_KRS_AusenciasProgramadas_AGrabar.id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO,false);

                if (mdl_KRS_AusenciasProgramadas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_AusenciasProgramadas_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Datos viejos para la trazabilidar
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_AusenciasProgramadas_Final, mdl_KRS_AusenciasProgramadas_DatosViejos, false, false);
                    
                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_AusenciasProgramadas_AGrabar, mdl_KRS_AusenciasProgramadas_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRS_AusenciasProgramadas) +
                                           " SET " +
                                                nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado," +
                                                nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "=@idAusenciaProgramadaTipo," +
                                                nameof(KRS_AusenciasProgramadas.fechaDesde) + "=@fechaDesde," +
                                                nameof(KRS_AusenciasProgramadas.fechaHasta) + "=@fechaHasta," +
                                                nameof(KRS_AusenciasProgramadas.fechaBorrado) + "=@fechaBorrado," +
                                                nameof(KRS_AusenciasProgramadas.totalDias) + "=@totalDias," +
                                                nameof(KRS_AusenciasProgramadas.totalHoras) + "=@totalHoras" +
                                           " WHERE " +
                                               nameof(KRS_AusenciasProgramadas.id) + "=@id ";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigoCliente",  mdl_KRS_AusenciasProgramadas_Final.codigoCliente),
                        new SqlParameter("@idEmpleado", mdl_KRS_AusenciasProgramadas_Final.idEmpleado),
                        new SqlParameter("@idAusenciaProgramadaTipo", mdl_KRS_AusenciasProgramadas_Final.idAusenciaProgramadaTipo),
                        new SqlParameter("@fechaDesde", mdl_KRS_AusenciasProgramadas_Final.fechaDesde),
                        mdl_KRS_AusenciasProgramadas_Final.fechaHasta != null
                            ?   new SqlParameter("@fechaHasta", mdl_KRS_AusenciasProgramadas_Final.fechaHasta.Value)
                            :   new SqlParameter("@fechaHasta",  DBNull.Value),
                        mdl_KRS_AusenciasProgramadas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_AusenciasProgramadas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_KRS_AusenciasProgramadas_Final.totalDias != null
                            ?   new SqlParameter("@totalDias", mdl_KRS_AusenciasProgramadas_Final.totalDias.Value)
                            :   new SqlParameter("@totalDias",  DBNull.Value),
                        mdl_KRS_AusenciasProgramadas_Final.totalHoras != null
                            ?   new SqlParameter("@totalHoras", mdl_KRS_AusenciasProgramadas_Final.totalHoras.Value)
                            :   new SqlParameter("@totalHoras",  DBNull.Value),
                        new SqlParameter("@id", mdl_KRS_AusenciasProgramadas_Final.id),
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_AusenciasProgramadas_Final.id;
                }
                else
                {
                    mdl_KRS_AusenciasProgramadas_Final = new KRS_AusenciasProgramadas();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_AusenciasProgramadas_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Cargar los Datos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_AusenciasProgramadas_AGrabar, mdl_KRS_AusenciasProgramadas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRS_AusenciasProgramadas) +
                                               " (" +
                                                        nameof(KRS_AusenciasProgramadas.codigoCliente) + "," +
                                                        nameof(KRS_AusenciasProgramadas.idEmpleado) + "," +
                                                        nameof(KRS_AusenciasProgramadas.idAusenciaProgramadaTipo) + "," +
                                                        nameof(KRS_AusenciasProgramadas.fechaDesde) + "," +
                                                        nameof(KRS_AusenciasProgramadas.fechaHasta) + "," +
                                                        nameof(KRS_AusenciasProgramadas.fechaBorrado) + "," +
                                                        nameof(KRS_AusenciasProgramadas.totalDias) + "," +
                                                        nameof(KRS_AusenciasProgramadas.totalHoras) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(KRS_AusenciasProgramadas.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigoCliente," +
                                                   "@idEmpleado," +
                                                   "@idAusenciaProgramadaTipo," +
                                                   "@fechaDesde," +
                                                   "@fechaHasta," +
                                                   "@fechaBorrado," +
                                                   "@totalDias," +
                                                   "@totalHoras" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigoCliente",  mdl_KRS_AusenciasProgramadas_Final.codigoCliente),
                        new SqlParameter("@idEmpleado", mdl_KRS_AusenciasProgramadas_Final.idEmpleado),
                        new SqlParameter("@idAusenciaProgramadaTipo", mdl_KRS_AusenciasProgramadas_Final.idAusenciaProgramadaTipo),
                        new SqlParameter("@fechaDesde", mdl_KRS_AusenciasProgramadas_Final.fechaDesde),
                        mdl_KRS_AusenciasProgramadas_Final.fechaHasta != null
                            ?   new SqlParameter("@fechaHasta", mdl_KRS_AusenciasProgramadas_Final.fechaHasta.Value)
                            :   new SqlParameter("@fechaHasta",  DBNull.Value),
                        mdl_KRS_AusenciasProgramadas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_AusenciasProgramadas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_KRS_AusenciasProgramadas_Final.totalDias != null
                            ?   new SqlParameter("@totalDias", mdl_KRS_AusenciasProgramadas_Final.totalDias.Value)
                            :   new SqlParameter("@totalDias",  DBNull.Value),
                        mdl_KRS_AusenciasProgramadas_Final.totalHoras != null
                            ?   new SqlParameter("@totalHoras", mdl_KRS_AusenciasProgramadas_Final.totalHoras.Value)
                            :   new SqlParameter("@totalHoras",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_idEmpleado, long _lng_CodigoCliente,string _str_Fecha)
        {

            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
           
            try
            {
                //Primer Intento de Borrado
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Poner Pendiente la solicitud relacionada si hubiera una y estuviera aceptada .................................
                INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo_SOLICITUD = new INTERNO_ValorDevuelto_Modelo();
                mdl_INTERNO_ValorDevuelto_Modelo_SOLICITUD.TodoCorrecto = true;
                KRS_AusenciasProgramadas mdl_KRS_AusenciasProgramadas=Obtener_Modelo_Por_EmpleadoClienteFecha(_lng_idEmpleado, _lng_CodigoCliente,_str_Fecha);
                if (mdl_KRS_AusenciasProgramadas != null)
                {
                    KRS_SolicitudesAusenciasProgramadas_Datos obj_KRS_SolicitudesAusenciasProgramadas_Datos = new KRS_SolicitudesAusenciasProgramadas_Datos();
                    mdl_INTERNO_ValorDevuelto_Modelo_SOLICITUD=obj_KRS_SolicitudesAusenciasProgramadas_Datos.Borrar_Por_AusenciaProgramada(mdl_KRS_AusenciasProgramadas);
                }
                //..........................................................................................................

                if (mdl_INTERNO_ValorDevuelto_Modelo_SOLICITUD.TodoCorrecto)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRS_AusenciasProgramadas) +
                                                " SET " +
                                                nameof(KRS_AusenciasProgramadas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(KRS_AusenciasProgramadas.idEmpleado) + "=@idEmpleado and " +
                                                nameof(KRS_AusenciasProgramadas.codigoCliente) + "=@codigoCliente and " +
                                                " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas.fechaDesde) + ",103)=@fechaDesde and " +
                                                " CONVERT(VARCHAR(10), " + nameof(KRS_AusenciasProgramadas.fechaHasta) + ",103)=@fechaHasta ";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@idEmpleado", _lng_idEmpleado),
                        new SqlParameter("@codigoCliente", _lng_CodigoCliente),
                        new SqlParameter("@fechaDesde", _str_Fecha),
                        new SqlParameter("@fechaHasta", _str_Fecha)
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
                }
                else
                {
                    mdl_INTERNO_ValorDevuelto_Modelo= mdl_INTERNO_ValorDevuelto_Modelo_SOLICITUD;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_AusenciasProgramadas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
